<script lang="ts">
import { defineComponent } from "vue";
import * as cd from "../lib/chordDictionary";
import type { ChordDefinition } from "../lib/chordDictionary";

import ChordFretboard from "@/components/ChordFretboard.vue";
import ChordNameHtml from "@/components/ChordNameHtml.vue";
import ChordPositions from "@/components/ChordPositions.vue";
import type { PositionType, TxType } from "./ChordPosition.vue";

export default defineComponent({
  components: {
    ChordFretboard,
    ChordNameHtml,
    ChordPositions,
  },
  data() {
    return {
      shake: false,
    };
  },
  props: {
    scale: { type: Number, default: 1 },
    scaleUnit: { type: String, default: "em" },
    editable: { type: Boolean, default: true },
    calcChordName: { type: Boolean, default: false },
    forceCorrect: { type: Boolean, default: false },
    showNotes: { type: Boolean, default: false },
  },
  emits: {
    onPosUpdate(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      return true;
    },
  },
  expose: [
    "getChordDef",
    "doShake",
    "revealGuess",
    "updatePos",
    "reset",
    "doRipple",
    "revealQuickly",
  ],
  methods: {
    getChordDef() {
      return this.$refs.positions ? this.$refs.positions.getChordDef() : [];
    },
    doShake() {
      this.shake = true;
      setTimeout(() => {
        this.shake = false;
      }, 700);
    },
    doRipple(done: () => void) {
      this.$refs.positions.doRipple(done);
    },
    revealGuess(chordDef: ChordDefinition, done: () => null) {
      this.$refs.positions.revealGuess(chordDef, done);
    },
    revealQuickly(chordDef: ChordDefinition, done: () => null) {
      this.$refs.positions.revealQuickly(chordDef, done);
    },
    onPosUpdate(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      this.$emit("onPosUpdate", fretNo, stringNo, type, txType);
    },
    updatePos(
      fretNo: number,
      stringNo: number,
      type: PositionType,
      txType: TxType
    ) {
      this.$refs.positions.updatePosition(fretNo, stringNo, type, txType);
    },
    reset() {
      this.$refs.positions.reset();
    },
  },
  computed: {
    chordNames() {
      if (this.calcChordName) {
        const ret = cd.lookUpNames(this.getChordDef());
        return ret !== undefined ? ret : [];
      } else {
        return [];
      }
    },
  },
});
</script>
<template>
  <svg
    :class="{
      chord_diagram: true,
      shake: shake,
    }"
    :style="{ height: 6.1 * scale + scaleUnit, width: 4 * scale + scaleUnit }"
    viewBox="0, 10, 75, 116"
  >
    <ChordFretboard :startFret="0" />
    <ChordPositions
      ref="positions"
      :editable="editable"
      :initial-start-fret="0"
      :force-correct="forceCorrect"
      :show-notes="showNotes"
      @onPosUpdate="onPosUpdate"
    />
  </svg>
  <ChordNameHtml
    v-if="chordNames.length > 0"
    :chordNames="chordNames"
    :scale="scale"
  />
</template>
<style scoped>
.chord_diagram {
  font-size: 0.42cm;
  font-family: verdana, sans-serif;
  transition: all 1.5s ease;
}

.shake {
  animation: shake 0.6s cubic-bezier(0.36, 0.07, 0.19, 0.97) both;
  transform: translate3d(0, 0, 0);
}

@keyframes shake {
  5%,
  95% {
    transform: translate3d(-1px, 0, 0);
  }

  10%,
  90% {
    transform: translate3d(-2px, 0, 0);
  }

  20%,
  80% {
    transform: translate3d(3px, 0, 0);
  }

  30%,
  50%,
  70% {
    transform: translate3d(-4px, 0, 0);
  }

  40%,
  60% {
    transform: translate3d(4px, 0, 0);
  }
}
</style>
